/*
* InstantSferyx for Sakai - immediate integration plugin for the entire Sakai system
* this is an easy to integrate wrapper for the Sferyx JSyndrome HTMLEditor Applet http://www.sferyx.com
*/

var FCKeditor = function( instanceName, width, height, toolbarSet, value )
{
	this.InstanceName	= instanceName ;
	this.Width		= width			|| '100%' ;
	this.Height		= height		|| '400' ;
	this.ToolbarSet		= toolbarSet	|| 'Default' ;
	this.Value		= value			|| '' ;
	this.BasePath		= '/fckeditor/' ;
	this.CheckBrowser	= true ;
	this.DisplayErrors	= true ;
	this.EnableSafari	= true;
	this.EnableOpera	= true;
	this.Config		= new Object() ;
	this.OnError		= null ;
} 



FCKeditor.prototype.ReplaceTextarea = function()
{

    var _info = navigator.userAgent;
    var _ie = (_info.indexOf("MSIE") > 0 && _info.indexOf("Win") > 0 && _info.indexOf("Windows 3.1") < 0);
    
    
    var imageBrowsingPath=this.Config.ImageBrowserURL;
    var linkBrowsingPath=this.Config.LinkBrowserURL;
    
    
   
    
    if(imageBrowsingPath!=null)
    {
    	var index=imageBrowsingPath.indexOf('CurrentFolder=');
    	imageBrowsingPath=imageBrowsingPath.substr(index+14);
    }
    
    
    
    
    if(linkBrowsingPath!=null)
        {
        	var index=linkBrowsingPath.indexOf('CurrentFolder=');
        	linkBrowsingPath=linkBrowsingPath.substr(index+14);
   	}
   	else
   	{
   		linkBrowsingPath=imageBrowsingPath;
   	}
     
     
     
     var appletJarName='/library/editor/FCKeditor/HTMLEditorAppletEnterprise.jar';
     

    
    if(_ie)
	{ 
	
			var fieldName=document.getElementById(this.InstanceName).name;
	   		var appletString='<input type="hidden" value="" name="'+fieldName+'" id="'+this.InstanceName+'">'+
	    		'<OBJECT '+'classid="clsid:8AD9C840-044E-11D1-B3E9-00805F499D93" '+
        		'WIDTH = "'+this.Width+'" HEIGHT = "'+this.Height+'" NAME = "sfrx_htmleditor" id="'+this.InstanceName+'_editor" '+
        		'codebase="http://java.sun.com/products/plugin/autodl/jinstall-1_4-win.cab#Version=1,4,0,0">'+
			'<PARAM NAME = CODE VALUE = "sferyx.administration.editors.HTMLEditor">'+
			'<PARAM NAME = CODEBASE = "'+appletJarName+'">'+
			'<PARAM NAME = ARCHIVE VALUE = "'+appletJarName+'">'+
			'<PARAM NAME = NAME VALUE = "htmleditor">'+
			'<PARAM NAME="type" VALUE="application/x-java-applet;version=1.4">'+
			'<PARAM NAME="scriptable" VALUE="true">'+
			'<PARAM NAME ="supressRemoteFileDialog" VALUE="false">'+
			'<PARAM NAME ="supressLocalFileDialog" VALUE="false">'+
			'<PARAM NAME ="remoteBrowseLocation" VALUE="http://'+location.host+'/access/content/'+imageBrowsingPath+'?sbasedir=http://'+location.host+'/access/content/user/">'+
			
			
			'<PARAM NAME ="absoluteDocumentTranslationURL" VALUE="http://'+location.host+'/access/content/user/">'+
			'<PARAM NAME ="initialURLEncodedContent" VALUE="'+escape(document.getElementById(this.InstanceName).value)+'">'+
			'<PARAM NAME ="uploadContentAsMultipartFormData" VALUE="true">'+
			'<PARAM NAME ="saveURL" VALUE="http://'+location.host+'/sakai-fck-connector/SferyxUpload?Command=FileUpload&Type=Image&CurrentFolder='+imageBrowsingPath+'">'+
			'<PARAM NAME ="sakai_compatibility_mode" VALUE="true">'+ 
			'<PARAM NAME ="generateUniqueImageFilenames" VALUE="true">'+ 
			'<PARAM NAME ="useFixedFileNameNamingRule" VALUE="NewFile">'+ 
			'<PARAM NAME="useFlowToolbarLayout" VALUE="true">'+
			'<PARAM NAME = "uploadedObjectsTranslationPath" VALUE="http://'+location.host+'/access/content/'+imageBrowsingPath+'sferyx/uploaded_files/">'+
			'<PARAM name="useCookie"  value="'+document.cookie+'">'+
			'<PARAM name="mainMenuVisible"  value="false">'+
			'<PARAM name="statusbarVisible"  value="false">'+
			'<PARAM name="sourceEditorVisible"  value="false">'+
			'<PARAM name="previewVisible"  value="false">'+
			'<PARAM name="toolbarItemsToRemove"  value="styleClasses">'+
			'<COMMENT>'+
			'</COMMENT>'+
			'</OBJECT>';
			
			document.getElementById(this.InstanceName).outerHTML=appletString;
			var hiddenField=document.getElementById(this.InstanceName);
			var underlyingform=hiddenField.form;
	 		var oringianlFunct=window.onload;
	 		window.onload=function(){initAllformFieldsFF(underlyingform,hiddenField,oringianlFunct);};
	 		
	 		initAllformFieldsFF(underlyingform,hiddenField,oringianlFunct);
	 		 
	 		
	} 
	else
	{	  
		  
   			var fieldName=document.getElementById(this.InstanceName).name;
   			var appletString='<input type="hidden" value="" name="'+fieldName+'" id="'+this.InstanceName+'">'+
   			'<applet code="sferyx.administration.editors.HTMLEditor" codebase="'+appletJarName+'" archive="'+appletJarName+'" style="width:'+this.Width+';height:'+this.Height+';" width="'+this.Width+'" height="'+this.Height+'" name="sfrx_htmleditor" id="'+this.InstanceName+'_editor">'+
			'To start Sferyx HTML Editor applet Java Plug-in 1.4 is required. Get it here: http://java.sun.com/products/plugin/1.4/plugin-install.html'+
			'<PARAM NAME ="supressRemoteFileDialog" VALUE="false">'+
			'<PARAM NAME ="supressLocalFileDialog" VALUE="false">'+
			'<PARAM NAME ="remoteBrowseLocation" VALUE="http://'+location.host+'/access/content/'+imageBrowsingPath+'?sbasedir=http://'+location.host+'/access/content/user/">'+
			'<PARAM NAME ="absoluteDocumentTranslationURL" VALUE="http://'+location.host+'/access/content/user/">'+
			'<PARAM NAME ="initialURLEncodedContent" VALUE="'+escape(document.getElementById(this.InstanceName).value)+'">'+
			'<PARAM NAME ="uploadContentAsMultipartFormData" VALUE="true">'+
                       	'<PARAM NAME ="saveURL" VALUE="http://'+location.host+'/sakai-fck-connector/SferyxUpload?Command=FileUpload&Type=Image&CurrentFolder='+imageBrowsingPath+'">'+
                      	'<PARAM NAME ="sakai_compatibility_mode" VALUE="true">'+ 
                      	'<PARAM NAME ="generateUniqueImageFilenames" VALUE="true">'+ 
                      	'<PARAM NAME ="useFixedFileNameNamingRule" VALUE="NewFile">'+ 
                        '<PARAM NAME = "uploadedObjectsTranslationPath" VALUE="http://'+location.host+'/access/content/'+imageBrowsingPath+'sferyx/uploaded_files/">'+
                        '<PARAM name="useCookie"  value="'+document.cookie+'">'+
                        '<PARAM NAME="useFlowToolbarLayout" VALUE="true">'+
                        '<PARAM name="mainMenuVisible"  value="false">'+
			'<PARAM name="statusbarVisible"  value="false">'+
			'<PARAM name="sourceEditorVisible"  value="false">'+
			'<PARAM name="previewVisible"  value="false">'+
			'<PARAM name="toolbarItemsToRemove"  value="styleClasses">'+
			'</applet>'; 
			
			var myTextField = document.getElementById(this.InstanceName);
			var r = myTextField.ownerDocument.createRange();
			r.setStartBefore(myTextField);
			var df = r.createContextualFragment(appletString);
		 	myTextField.parentNode.replaceChild(df, myTextField);   
		 	
		 
		 	
	 		var hiddenField=document.getElementById(this.InstanceName);
			var underlyingform=hiddenField.form;
			var oringianlFunct=window.onload;
			window.onload=function(){initAllformFieldsFF(underlyingform,hiddenField,oringianlFunct);};
		
			
			initAllformFieldsFF(underlyingform,hiddenField,oringianlFunct);
			
		 	
	}
	
	  

}  
 

function initAllformFieldsFF(underlyingform,hiddenField,oringianlFunct)
{

  
 				for (x=0; underlyingform[x]; x++)
				 {
				      objEl = underlyingform[x];
				    
				      if (objEl.type == 'submit'||objEl.type == 'button'||objEl.type == 'checkbox')
				      {
				         
				         objEl.onmouseup=function(){sending();};
				      }
				
				 }
				 
				 
				 var links = document.getElementsByTagName('a');

				 for (i=0; links[i]; i++)
				 {
				      if (links[i].onclick!=null)
				      {
				      
				      	
				      	links[i].onmouseup=function(){sending();};
				      }
				 }
				 
	if(oringianlFunct)
	{			 
		oringianlFunct();
	}
	
	
	
	
		
 
} 


function sending()
{
	
	
	
	fieldsToAttach=document.getElementsByName('sfrx_htmleditor');

	for(x=0;fieldsToAttach;x++)
	{

		hiddenFieldID=fieldsToAttach[x].id.substring(0,fieldsToAttach[x].id.length-7);
		hiddenField=document.getElementById(hiddenFieldID);
		htmleditor_=fieldsToAttach[x];//document.getElementById(hiddenField.id+'_editor');

		htmleditor_.saveToDefaultLocation();
		var content=htmleditor_.getBodyContent();
		hiddenField.value=content;
	}
	
	
	
	
}
  
 